"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var config_1 = __importDefault(require("config"));
var node_fetch_1 = require("node-fetch");
var baseCommand_1 = __importStar(require("../../lib/baseCommand"));
var getCategories_1 = __importDefault(require("../../lib/getCategories"));
var readmeAPIFetch_1 = __importStar(require("../../lib/readmeAPIFetch"));
var versionSelect_1 = require("../../lib/versionSelect");
var CategoriesCreateCommand = /** @class */ (function (_super) {
    __extends(CategoriesCreateCommand, _super);
    function CategoriesCreateCommand() {
        var _this = _super.call(this) || this;
        _this.command = 'categories:create';
        _this.usage = 'categories:create <title> [options]';
        _this.description = 'Create a category with the specified title and guide in your ReadMe project.';
        _this.cmdCategory = baseCommand_1.CommandCategories.CATEGORIES;
        _this.hiddenArgs = ['title'];
        _this.args = [
            _this.getKeyArg(),
            _this.getVersionArg(),
            {
                name: 'title',
                type: String,
                defaultOption: true,
            },
            {
                name: 'categoryType',
                type: String,
                description: 'Category type, must be `guide` or `reference`',
            },
            {
                name: 'preventDuplicates',
                type: Boolean,
                description: 'Prevents the creation of a new category if there is an existing category with a matching `categoryType` and `title`',
            },
        ];
        return _this;
    }
    CategoriesCreateCommand.prototype.run = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            function matchCategory() {
                return __awaiter(this, void 0, void 0, function () {
                    var allCategories;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, (0, getCategories_1.default)(key, selectedVersion)];
                            case 1:
                                allCategories = _a.sent();
                                return [2 /*return*/, allCategories.find(function (category) {
                                        return category.title.trim().toLowerCase() === title.trim().toLowerCase() && category.type === categoryType;
                                    })];
                        }
                    });
                });
            }
            function createCategory() {
                return __awaiter(this, void 0, void 0, function () {
                    var matchedCategory;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!preventDuplicates) return [3 /*break*/, 2];
                                return [4 /*yield*/, matchCategory()];
                            case 1:
                                matchedCategory = _a.sent();
                                if (typeof matchedCategory !== 'undefined') {
                                    return [2 /*return*/, Promise.reject(new Error("The '".concat(matchedCategory.title, "' category with a type of '").concat(matchedCategory.type, "' already exists with an id of '").concat(matchedCategory.id, "'. A new category was not created.")))];
                                }
                                _a.label = 2;
                            case 2: return [2 /*return*/, (0, readmeAPIFetch_1.default)('/api/v1/categories', {
                                    method: 'post',
                                    headers: (0, readmeAPIFetch_1.cleanHeaders)(key, new node_fetch_1.Headers({
                                        'x-readme-version': selectedVersion,
                                        'Content-Type': 'application/json',
                                    })),
                                    body: JSON.stringify({
                                        title: title,
                                        type: categoryType,
                                    }),
                                })
                                    .then(readmeAPIFetch_1.handleRes)
                                    .then(function (res) { return "\uD83C\uDF31 successfully created '".concat(res.title, "' with a type of '").concat(res.type, "' and an id of '").concat(res.id, "'"); })];
                        }
                    });
                });
            }
            var categoryType, title, key, version, preventDuplicates, selectedVersion, createdCategory, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, _super.prototype.run.call(this, opts)];
                    case 1:
                        _c.sent();
                        categoryType = opts.categoryType, title = opts.title, key = opts.key, version = opts.version, preventDuplicates = opts.preventDuplicates;
                        if (!title) {
                            return [2 /*return*/, Promise.reject(new Error("No title provided. Usage `".concat(config_1.default.get('cli'), " ").concat(this.usage, "`.")))];
                        }
                        if (categoryType !== 'guide' && categoryType !== 'reference') {
                            return [2 /*return*/, Promise.reject(new Error('`categoryType` must be `guide` or `reference`.'))];
                        }
                        return [4 /*yield*/, (0, versionSelect_1.getProjectVersion)(version, key)];
                    case 2:
                        selectedVersion = _c.sent();
                        baseCommand_1.default.debug("selectedVersion: ".concat(selectedVersion));
                        _b = (_a = chalk_1.default).green;
                        return [4 /*yield*/, createCategory()];
                    case 3:
                        createdCategory = _b.apply(_a, [_c.sent()]);
                        return [2 /*return*/, Promise.resolve(createdCategory)];
                }
            });
        });
    };
    return CategoriesCreateCommand;
}(baseCommand_1.default));
exports.default = CategoriesCreateCommand;
