"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSupportedFeatures = void 0;
var analyzer_1 = __importDefault(require("oas/dist/analyzer"));
var OPENAPI_FEATURE_DOCS = {
    additionalProperties: {
        description: 'additionalProperties allows you to document dictionaries where the keys are user-supplied strings.',
        url: {
            '3.0': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.0.3.md#schema-object',
            '3.1': 'https://json-schema.org/understanding-json-schema/reference/object.html#additional-properties',
        },
    },
    callbacks: {
        description: 'Callbacks are asynchronous, out-of-band requests that your service will send to some other service in response to certain events.',
        url: {
            '3.0': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.0.3.md#callback-object',
            '3.1': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.1.0.md#callback-object',
        },
    },
    circularRefs: {
        description: 'Circular references are $ref pointers that at some point in their lineage reference themselves.',
    },
    discriminators: {
        description: 'With schemas that can be, or contain, different shapes, discriminators help you assist your users in identifying and determining the kind of shape they can supply or receive.',
        url: {
            '3.0': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.0.3.md#discriminator-object',
            '3.1': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.1.0.md#discriminator-object',
        },
    },
    links: {
        description: 'Links allow you to define at call-time relationships to other operations within your API.',
        url: {
            '3.0': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.0.3.md#link-object',
            '3.1': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.1.0.md#link-object',
        },
    },
    style: {
        description: 'Parameter serialization (style) allows you to describe how the parameter should be sent to your API.',
        url: {
            '3.0': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.0.3.md#parameter-style',
            '3.1': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.1.0.md#parameter-style',
        },
    },
    polymorphism: {
        description: 'Polymorphism (allOf, oneOf, and anyOf) allow you to describe schemas that may contain either many different shapes, or a single shape containing multiple different schemas.',
        url: {
            '3.0': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.0.3.md#schema-object',
            '3.1': 'https://json-schema.org/understanding-json-schema/reference/combining.html',
        },
    },
    serverVariables: {
        description: 'Server variables allow to do user-supplied variable subsitituions within your API server URL.',
        url: {
            '3.0': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.0.3.md#server-variable-object',
            '3.1': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.1.0.md#server-variable-object',
        },
    },
    webhooks: {
        description: 'Webhooks allow you to describe out of band requests that may be initiated by your users.',
        url: {
            '3.1': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.1.0.md#user-content-oaswebhooks',
        },
    },
    xml: {
        description: 'Any parameter and/or request body that accepts XML or responses that return XML payloads.',
        url: {
            '3.0': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.0.3.md#xml-object',
            '3.1': 'https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.1.0.md#xml-object',
        },
    },
};
var README_FEATURE_DOCS = {
    'x-default': {
        description: 'The x-default extension allows you to define static authentication credential defaults for OAuth 2 and API Key security types.',
        url: 'https://docs.readme.com/main/docs/openapi-extensions#authentication-defaults',
    },
    'x-readme.code-samples': {
        description: 'The x-readme.code-samples extension allows you to custom, create static code samples on your API documentation.',
        url: 'https://docs.readme.com/main/docs/openapi-extensions#custom-code-samples',
    },
    'x-readme.headers': {
        description: 'The x-readme.headers extension allows you define headers that should always be present on your API or a specific operation, as well as what its value should be.',
        url: 'https://docs.readme.com/main/docs/openapi-extensions#static-headers',
    },
    'x-readme.explorer-enabled': {
        description: 'The x-readme.explorer-enabled extension allows you to toggle your API documentation being interactive or not.',
        url: 'https://docs.readme.com/main/docs/openapi-extensions#disable-the-api-explorer',
    },
    'x-readme.proxy-enabled': {
        description: "The x-readme.proxy-enabled extension allows you to toggle if API requests from API documentation should be routed through ReadMe's CORS Proxy. You should only need to use this if your API does not support CORS.",
        url: 'https://docs.readme.com/main/docs/openapi-extensions#cors-proxy-enabled',
    },
    'x-readme.samples-languages': {
        description: 'The x-readme.samples-languages extension allows you to toggle what languages are shown by default for code snippets in your API documentation.',
        url: 'https://docs.readme.com/main/docs/openapi-extensions#code-sample-languages',
    },
    'x-readme.samples-enabled': {
        description: 'The x-readme.samples-enabled extension allowed you to disable code samples on specific endpoints. It is no longer supported and can be safely removed from your API definition.',
        url: 'https://docs.readme.com/main/docs/openapi-extensions#disable-code-examples',
    },
    raw_body: {
        description: "The RAW_BODY property allows you to define that a request body should have its payload delivered as a raw string. This legacy feature is specific to our Manual API editor and we don't recommend you use it outside of that context, instead opting for a traditional `type: string, format: blob` schema definition.",
    },
};
/**
 * Analyze a given OpenAPI or Swagger definition for any OpenAPI, JSON Schema, and ReadMe-specific
 * feature uses it may contain.
 *
 */
function analyzeOas(definition) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, (0, analyzer_1.default)(definition).then(function (analysis) {
                    if (analysis.openapi) {
                        Object.entries(OPENAPI_FEATURE_DOCS).forEach(function (_a) {
                            var _b = __read(_a, 2), feature = _b[0], docs = _b[1];
                            // eslint-disable-next-line no-param-reassign
                            analysis.openapi[feature] = __assign(__assign({}, analysis.openapi[feature]), docs);
                        });
                    }
                    if (analysis.readme) {
                        Object.entries(README_FEATURE_DOCS).forEach(function (_a) {
                            var _b = __read(_a, 2), feature = _b[0], docs = _b[1];
                            // If this ReadMe feature isn't in our resulted analysis result then it's a deprecated
                            // feature that this API definition doesn't contain so we don't need to inform the user of
                            // something they neither use, can't use anyways, nor should know about.
                            if (!(feature in analysis.readme)) {
                                return;
                            }
                            // eslint-disable-next-line no-param-reassign
                            analysis.readme[feature] = __assign(__assign({}, analysis.readme[feature]), docs);
                        });
                    }
                    return analysis;
                })];
        });
    });
}
function getSupportedFeatures() {
    return __spreadArray(__spreadArray([], __read(Object.keys(OPENAPI_FEATURE_DOCS)), false), [
        'readme', // A catch-all for ReadMe features and extensions. Will look for everything.
    ], false);
}
exports.getSupportedFeatures = getSupportedFeatures;
exports.default = analyzeOas;
