"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSimilar = exports.listByCategory = exports.load = exports.list = exports.getCategories = void 0;
var cmds_1 = __importDefault(require("../cmds"));
function getCategories() {
    return {
        apis: {
            description: 'OpenAPI / Swagger',
            commands: [],
        },
        docs: {
            description: 'Docs (a.k.a. Guides)',
            commands: [],
        },
        changelogs: {
            description: 'Changelog',
            commands: [],
        },
        custompages: {
            description: 'Custom Pages',
            commands: [],
        },
        versions: {
            description: 'Versions',
            commands: [],
        },
        categories: {
            description: 'Categories',
            commands: [],
        },
        admin: {
            description: 'Administration',
            commands: [],
        },
        utilities: {
            description: 'Other useful commands',
            commands: [],
        },
    };
}
exports.getCategories = getCategories;
function list() {
    return Object.entries(cmds_1.default).map(function (_a) {
        var _b = __read(_a, 2), name = _b[0], Cmd = _b[1];
        return {
            name: name,
            command: new Cmd(),
        };
    });
}
exports.list = list;
function load(cmd) {
    if (!(cmd in cmds_1.default)) {
        throw new Error('Command not found.');
    }
    return new cmds_1.default[cmd]();
}
exports.load = load;
function listByCategory() {
    var categories = getCategories();
    var cmds = list();
    cmds.forEach(function (c) {
        categories[c.command.cmdCategory].commands.push({
            name: c.command.command,
            description: c.command.description,
            hidden: c.command.hidden,
        });
    });
    return categories;
}
exports.listByCategory = listByCategory;
function getSimilar(cmdCategory, excludeCommand) {
    var categories = listByCategory();
    return categories[cmdCategory].commands.filter(function (cmd) { return cmd.name !== excludeCommand && !cmd.hidden; });
}
exports.getSimilar = getSimilar;
