"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * The base GitHub Actions workflow file, which is used for generating the YAML file.
 *
 * The reason this is expressed as a JavaScript string as opposed to a YAML file is because
 * TypeScript doesn't have a great way to copy over non-TS files to the `dist/`.
 * Plus, this way we can write internal comments like this!
 *
 * @see {@link https://github.com/microsoft/TypeScript/issues/30835}
 * @see {@link https://docs.github.com/actions/using-workflows/workflow-syntax-for-github-actions}
 */
var yamlBase = "# This GitHub Actions workflow was auto-generated by the `rdme` cli on {{timestamp}}\n# You can view our full documentation here: https://docs.readme.com/docs/rdme\nname: ReadMe GitHub Action \uD83E\uDD89\n\non:\n  push:\n    branches:\n      # This workflow will run every time you push code to the following branch: `{{branch}}`\n      # Check out GitHub's docs for more info on configuring this:\n      # https://docs.github.com/actions/using-workflows/events-that-trigger-workflows\n      - {{branch}}\n\njobs:\n  rdme-{{cleanCommand}}:\n    runs-on: ubuntu-latest\n    steps:\n      - name: Check out repo \uD83D\uDCDA\n        uses: actions/checkout@v3\n\n      - name: Run `{{command}}` command \uD83D\uDE80\n        uses: readmeio/rdme@{{rdmeVersion}}\n        with:\n          rdme: {{commandString}}\n";
exports.default = yamlBase;
