"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGitData = exports.getGHAFileName = exports.git = exports.getConfigStoreKey = void 0;
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var chalk_1 = __importDefault(require("chalk"));
var prompts_1 = __importDefault(require("prompts"));
var simple_git_1 = __importDefault(require("simple-git"));
var configstore_1 = __importDefault(require("../configstore"));
var getPkgVersion_1 = require("../getPkgVersion");
var isCI_1 = __importStar(require("../isCI"));
var logger_1 = require("../logger");
var promptWrapper_1 = __importDefault(require("../promptWrapper"));
var validatePromptInput_1 = require("../validatePromptInput");
var baseFile_1 = __importDefault(require("./baseFile"));
/**
 * Generates the key for storing info in `configstore` object.
 * @param repoRoot The root of the repo
 */
var getConfigStoreKey = function (repoRoot) { return "createGHA.".concat(repoRoot); };
exports.getConfigStoreKey = getConfigStoreKey;
/**
 * The directory where GitHub Actions workflow files are stored.
 *
 * This is the same across all repositories on GitHub.
 *
 * @see {@link https://docs.github.com/en/actions/using-workflows/workflow-syntax-for-github-actions#about-yaml-syntax-for-workflows}
 */
var GITHUB_WORKFLOW_DIR = '.github/workflows';
var GITHUB_SECRET_NAME = 'README_API_KEY';
exports.git = (0, simple_git_1.default)();
/**
 * Removes any non-file-friendly characters and adds
 * the full path + file extension for GitHub Workflow files.
 * @param fileName raw file name to clean up
 */
var getGHAFileName = function (fileName) {
    return path_1.default.join(GITHUB_WORKFLOW_DIR, "".concat((0, validatePromptInput_1.cleanFileName)(fileName).toLowerCase(), ".yml"));
};
exports.getGHAFileName = getGHAFileName;
/**
 * Returns a redacted `key` if the current command uses authentication.
 * Otherwise, returns `false`.
 */
function getKey(args, opts) {
    if (args.some(function (arg) { return arg.name === 'key'; })) {
        return "\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022\u2022".concat(opts.key.slice(-5));
    }
    return false;
}
/**
 * Constructs the command string that we pass into the workflow file.
 */
function constructCmdString(command, args, opts) {
    var optsString = args
        .sort(function (arg) { return (arg.defaultOption ? -1 : 0); })
        .map(function (arg) {
        var val = opts[arg.name];
        // if default option, return the value
        if (arg.defaultOption)
            return val;
        // obfuscate the key in a GitHub secret
        if (arg.name === 'key')
            return "--key=${{ secrets.".concat(GITHUB_SECRET_NAME, " }}");
        // remove the GitHub flag
        if (arg.name === 'github')
            return false;
        // if a boolean value, return the flag
        if (arg.type === Boolean && val)
            return "--".concat(arg.name);
        if (val)
            return "--".concat(arg.name, "=").concat(val);
        return false;
    })
        .filter(Boolean)
        .join(' ');
    return "".concat(command, " ").concat(optsString).trim();
}
/**
 * Function to return various git attributes needed for running GitHub Action
 */
function getGitData() {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var headRegEx, headLineRegEx, isRepo, containsGitHubRemote, defaultBranch, rawRemotes, remote, rawRemote, rawHead, remotesList, repoRoot;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    headRegEx = /^ {2}HEAD branch: /g;
                    headLineRegEx = /^ {2}HEAD branch:.*/gm;
                    return [4 /*yield*/, exports.git.checkIsRepo().catch(function (e) {
                            (0, logger_1.debug)("error running git repo check: ".concat(e.message));
                            return false;
                        })];
                case 1:
                    isRepo = _b.sent();
                    (0, logger_1.debug)("[getGitData] isRepo result: ".concat(isRepo));
                    return [4 /*yield*/, exports.git.remote([]).catch(function (e) {
                            (0, logger_1.debug)("[getGitData] error grabbing git remotes: ".concat(e.message));
                            return '';
                        })];
                case 2:
                    rawRemotes = _b.sent();
                    (0, logger_1.debug)("[getGitData] rawRemotes result: ".concat(rawRemotes));
                    if (!rawRemotes) return [3 /*break*/, 5];
                    remote = rawRemotes.split('\n')[0];
                    (0, logger_1.debug)("[getGitData] remote result: ".concat(remote));
                    return [4 /*yield*/, exports.git.remote(['show', remote]).catch(function (e) {
                            (0, logger_1.debug)("[getGitData] error accessing remote: ".concat(e.message));
                            return '';
                        })];
                case 3:
                    rawRemote = _b.sent();
                    (0, logger_1.debug)("[getGitData] rawRemote result: ".concat(rawRemote));
                    rawHead = (_a = headLineRegEx.exec(rawRemote)) === null || _a === void 0 ? void 0 : _a[0];
                    (0, logger_1.debug)("[getGitData] rawHead result: ".concat(rawHead));
                    if (rawHead)
                        defaultBranch = rawHead.replace(headRegEx, '');
                    return [4 /*yield*/, exports.git.remote(['-v'])];
                case 4:
                    remotesList = (_b.sent());
                    (0, logger_1.debug)("[getGitData] remotesList result: ".concat(remotesList));
                    // This is a bit hairy but we want to keep it fairly general here
                    // in case of GitHub Enterprise, etc.
                    containsGitHubRemote = /github/.test(remotesList);
                    _b.label = 5;
                case 5:
                    (0, logger_1.debug)("[getGitData] containsGitHubRemote result: ".concat(containsGitHubRemote));
                    (0, logger_1.debug)("[getGitData] defaultBranch result: ".concat(defaultBranch));
                    return [4 /*yield*/, exports.git.revparse(['--show-toplevel']).catch(function (e) {
                            (0, logger_1.debug)("[getGitData] error grabbing git root: ".concat(e.message));
                            return '';
                        })];
                case 6:
                    repoRoot = _b.sent();
                    (0, logger_1.debug)("[getGitData] repoRoot result: ".concat(repoRoot));
                    return [2 /*return*/, { containsGitHubRemote: containsGitHubRemote, defaultBranch: defaultBranch, isRepo: isRepo, repoRoot: repoRoot }];
            }
        });
    });
}
exports.getGitData = getGitData;
/**
 * Post-command flow for creating a GitHub Actions workflow file.
 *
 */
function createGHA(msg, command, args, opts) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, containsGitHubRemote, defaultBranch, isRepo, repoRoot, configVal, majorPkgVersion, _b, branch, filePath, shouldCreateGHA, data, output, success, key;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    (0, logger_1.debug)("running GHA onboarding for ".concat(command, " command"));
                    (0, logger_1.debug)("opts used in createGHA: ".concat(JSON.stringify(opts)));
                    // if in a CI environment,
                    // don't even bother running the git commands
                    if (!opts.github && ((0, isCI_1.default)() || (0, isCI_1.isNpmScript)())) {
                        (0, logger_1.debug)('not running GHA onboarding workflow in CI and/or npm script, exiting');
                        return [2 /*return*/, msg];
                    }
                    return [4 /*yield*/, getGitData()];
                case 1:
                    _a = _c.sent(), containsGitHubRemote = _a.containsGitHubRemote, defaultBranch = _a.defaultBranch, isRepo = _a.isRepo, repoRoot = _a.repoRoot;
                    configVal = configstore_1.default.get((0, exports.getConfigStoreKey)(repoRoot));
                    (0, logger_1.debug)("repo value in config: ".concat(configVal));
                    return [4 /*yield*/, (0, getPkgVersion_1.getMajorPkgVersion)()];
                case 2:
                    majorPkgVersion = _c.sent();
                    (0, logger_1.debug)("major pkg version: ".concat(majorPkgVersion));
                    if (!opts.github) {
                        if (
                        // not a repo
                        !isRepo ||
                            // user has previously declined to set up GHA for current repo and `rdme` package version
                            configVal === majorPkgVersion ||
                            // is a repo, but does not contain a GitHub remote
                            (isRepo && !containsGitHubRemote) ||
                            // not testing this function
                            ((0, isCI_1.isTest)() && !process.env.TEST_RDME_CREATEGHA)) {
                            (0, logger_1.debug)('not running GHA onboarding workflow, exiting');
                            // We return the original command message and pretend this command flow never happened.
                            return [2 /*return*/, msg];
                        }
                    }
                    if (msg)
                        (0, logger_1.info)(msg, { includeEmojiPrefix: false });
                    if (opts.github) {
                        (0, logger_1.info)(chalk_1.default.bold("\n🚀 Let's get you set up with GitHub Actions! 🚀\n"), { includeEmojiPrefix: false });
                    }
                    else {
                        (0, logger_1.info)([
                            '',
                            chalk_1.default.bold("🐙 Looks like you're running this command in a GitHub Repository! 🐙"),
                            '',
                            "\uD83D\uDE80 With a few quick clicks, you can run this `".concat(command, "` command via GitHub Actions (").concat(chalk_1.default.underline('https://github.com/features/actions'), ")"),
                            '',
                            "\u2728 This means it will run ".concat(chalk_1.default.italic('automagically'), " with every push to a branch of your choice!"),
                            '',
                        ].join('\n'), { includeEmojiPrefix: false });
                    }
                    if (repoRoot)
                        process.chdir(repoRoot);
                    prompts_1.default.override({ shouldCreateGHA: opts.github });
                    return [4 /*yield*/, (0, promptWrapper_1.default)([
                            {
                                message: 'Would you like to add a GitHub Actions workflow?',
                                name: 'shouldCreateGHA',
                                type: 'confirm',
                                initial: true,
                            },
                            {
                                message: 'What GitHub branch should this workflow run on?',
                                name: 'branch',
                                type: 'text',
                                initial: defaultBranch || 'main',
                            },
                            {
                                message: 'What would you like to name the GitHub Actions workflow file?',
                                name: 'filePath',
                                type: 'text',
                                initial: (0, validatePromptInput_1.cleanFileName)("rdme-".concat(command)),
                                format: function (prev) { return (0, exports.getGHAFileName)(prev); },
                                validate: function (value) { return (0, validatePromptInput_1.validateFilePath)(value, exports.getGHAFileName); },
                            },
                        ], {
                            // @ts-expect-error answers is definitely an object,
                            // despite TS insisting that it's an array.
                            // link: https://github.com/terkelg/prompts#optionsonsubmit
                            onSubmit: function (p, a, answers) { return !answers.shouldCreateGHA; },
                        })];
                case 3:
                    _b = _c.sent(), branch = _b.branch, filePath = _b.filePath, shouldCreateGHA = _b.shouldCreateGHA;
                    if (!shouldCreateGHA) {
                        // if the user says no, we don't want to bug them again
                        // for this repo and version of `rdme
                        configstore_1.default.set((0, exports.getConfigStoreKey)(repoRoot), majorPkgVersion);
                        throw new Error('GitHub Actions workflow creation cancelled. If you ever change your mind, you can run this command again with the `--github` flag.');
                    }
                    data = {
                        branch: branch,
                        cleanCommand: (0, validatePromptInput_1.cleanFileName)(command),
                        command: command,
                        commandString: constructCmdString(command, args, opts),
                        rdmeVersion: "v".concat(majorPkgVersion),
                        timestamp: new Date().toISOString(),
                    };
                    (0, logger_1.debug)("data for resolver: ".concat(JSON.stringify(data)));
                    output = baseFile_1.default;
                    Object.keys(data).forEach(function (key) {
                        output = output.replace(new RegExp("{{".concat(key, "}}"), 'g'), data[key]);
                    });
                    if (!fs_1.default.existsSync(GITHUB_WORKFLOW_DIR)) {
                        (0, logger_1.debug)('GHA workflow directory does not exist, creating');
                        fs_1.default.mkdirSync(GITHUB_WORKFLOW_DIR, { recursive: true });
                    }
                    fs_1.default.writeFileSync(filePath, output);
                    success = [chalk_1.default.green('\nYour GitHub Actions workflow file has been created! ✨\n')];
                    key = getKey(args, opts);
                    if (key) {
                        success.push(chalk_1.default.bold('Almost done! Just a couple more steps:'), "1. Push your newly created file (".concat(chalk_1.default.underline(filePath), ") to GitHub \uD83D\uDE80"), "2. Create a GitHub secret called ".concat(chalk_1.default.bold(GITHUB_SECRET_NAME), " and populate the value with your ReadMe API key (").concat(key, ") \uD83D\uDD11"), '', "\uD83D\uDD10 Check out GitHub's docs for more info on creating encrypted secrets (".concat(chalk_1.default.underline('https://docs.github.com/actions/security-guides/encrypted-secrets#creating-encrypted-secrets-for-a-repository'), ")"));
                    }
                    else {
                        success.push("".concat(chalk_1.default.bold('Almost done!'), " Push your newly created file (").concat(chalk_1.default.underline(filePath), ") to GitHub and you're all set \uD83D\uDE80"));
                    }
                    success.push('', "\uD83E\uDD89 If you have any more questions, feel free to drop us a line! ".concat(chalk_1.default.underline('support@readme.io')), '');
                    return [2 /*return*/, Promise.resolve(success.join('\n'))];
            }
        });
    });
}
exports.default = createGHA;
