"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var configstore_1 = __importDefault(require("./configstore"));
/**
 * Retrieves stored user data values from env variables or configstore,
 * with env variables taking precedent
 */
function getCurrentConfig() {
    var apiKey = process.env.RDME_API_KEY || configstore_1.default.get('apiKey');
    var email = process.env.RDME_EMAIL || configstore_1.default.get('email');
    var project = process.env.RDME_PROJECT || configstore_1.default.get('project');
    return { apiKey: apiKey, email: email, project: project };
}
exports.default = getCurrentConfig;
