"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMajorPkgVersion = exports.getPkgVersion = exports.getNodeVersion = void 0;
// eslint-disable-next-line no-restricted-imports
var node_fetch_1 = __importDefault(require("node-fetch"));
var semver_1 = __importDefault(require("semver"));
var package_json_1 = __importDefault(require("../../package.json"));
var logger_1 = require("./logger");
var registryUrl = 'https://registry.npmjs.com/rdme';
/**
 * Return the major Node.js version specified in our `package.json` config.
 *
 * @example 14
 */
function getNodeVersion() {
    var node = package_json_1.default.engines.node;
    return semver_1.default.minVersion(node).major;
}
exports.getNodeVersion = getNodeVersion;
/**
 * The current `rdme` version
 *
 * @param npmDistTag the `npm` dist tag to retrieve. If this value is omitted,
 * the version from the `package.json` is returned.
 * @example "8.0.0"
 * @see {@link https://docs.npmjs.com/adding-dist-tags-to-packages}
 * @note we mock this function in our snapshots, hence it's not the default
 * @see {@link https://stackoverflow.com/a/54245672}
 */
function getPkgVersion(npmDistTag) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (npmDistTag) {
                return [2 /*return*/, (0, node_fetch_1.default)(registryUrl)
                        .then(function (res) { return res.json(); })
                        .then(function (body) { return body['dist-tags'][npmDistTag]; })
                        .catch(function (err) {
                        (0, logger_1.error)("error fetching version from npm registry: ".concat(err.message));
                        return package_json_1.default.version;
                    })];
            }
            return [2 /*return*/, package_json_1.default.version];
        });
    });
}
exports.getPkgVersion = getPkgVersion;
/**
 * The current major `rdme` version
 *
 * @example 8
 */
var getMajorPkgVersion = function (npmDistTag) { return __awaiter(void 0, void 0, void 0, function () { var _a, _b; return __generator(this, function (_c) {
    switch (_c.label) {
        case 0:
            _b = (_a = semver_1.default).major;
            return [4 /*yield*/, getPkgVersion(npmDistTag)];
        case 1: return [2 /*return*/, _b.apply(_a, [_c.sent()])];
    }
}); }); };
exports.getMajorPkgVersion = getMajorPkgVersion;
