"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var isEmail_1 = __importDefault(require("validator/lib/isEmail"));
var configstore_1 = __importDefault(require("./configstore"));
var getCurrentConfig_1 = __importDefault(require("./getCurrentConfig"));
var logger_1 = require("./logger");
var promptWrapper_1 = __importDefault(require("./promptWrapper"));
var readmeAPIFetch_1 = __importStar(require("./readmeAPIFetch"));
var validatePromptInput_1 = require("./validatePromptInput");
function loginFetch(body) {
    return (0, readmeAPIFetch_1.default)('/api/v1/login', {
        method: 'post',
        headers: { Accept: 'application/json', 'Content-Type': 'application/json' },
        body: JSON.stringify(body),
    });
}
/**
 * The prompt flow for logging a user in and writing the credentials to
 * `configstore`. This is a separate lib function because we reuse it both
 * in the `login` command as well as any time a user omits an API key.
 * @param otp an optional one-time passcode, if the user passes one in
 * via a flag to the the `login` command
 * @returns A Promise-wrapped string with the logged-in user's credentials
 */
function loginFlow(otp) {
    return __awaiter(this, void 0, void 0, function () {
        var storedConfig, _a, email, password, project, payload;
        var _this = this;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    storedConfig = (0, getCurrentConfig_1.default)();
                    return [4 /*yield*/, (0, promptWrapper_1.default)([
                            {
                                type: 'text',
                                name: 'email',
                                message: 'What is your email address?',
                                initial: storedConfig.email,
                                validate: function (val) {
                                    return (0, isEmail_1.default)(val) ? true : 'Please provide a valid email address.';
                                },
                            },
                            {
                                type: 'invisible',
                                name: 'password',
                                message: 'What is your password?',
                            },
                            {
                                type: 'text',
                                name: 'project',
                                message: 'What project subdomain are you logging into?',
                                initial: storedConfig.project,
                                validate: validatePromptInput_1.validateSubdomain,
                            },
                        ])];
                case 1:
                    _a = _b.sent(), email = _a.email, password = _a.password, project = _a.project;
                    if (!project) {
                        return [2 /*return*/, Promise.reject(new Error('No project subdomain provided. Please use `--project`.'))];
                    }
                    if (!(0, isEmail_1.default)(email)) {
                        return [2 /*return*/, Promise.reject(new Error('You must provide a valid email address.'))];
                    }
                    payload = { email: email, password: password, project: project };
                    // if the user passed in a `otp` option, include that in the login payload
                    if (otp)
                        payload.token = otp;
                    return [2 /*return*/, loginFetch(payload)
                            .then(readmeAPIFetch_1.handleRes)
                            .catch(function (err) { return __awaiter(_this, void 0, void 0, function () {
                            var otpPrompt;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!(err.code === 'LOGIN_TWOFACTOR')) return [3 /*break*/, 2];
                                        (0, logger_1.debug)('2FA error response, prompting for 2FA code');
                                        return [4 /*yield*/, (0, promptWrapper_1.default)({
                                                type: 'text',
                                                name: 'otp',
                                                message: 'What is your 2FA token?',
                                            })];
                                    case 1:
                                        otpPrompt = _a.sent();
                                        return [2 /*return*/, loginFetch({ email: email, password: password, project: project, token: otpPrompt.otp }).then(readmeAPIFetch_1.handleRes)];
                                    case 2: throw err;
                                }
                            });
                        }); })
                            .then(function (res) {
                            configstore_1.default.set('apiKey', res.apiKey);
                            configstore_1.default.set('email', email);
                            configstore_1.default.set('project', project);
                            return "Successfully logged in as ".concat(chalk_1.default.green(email), " to the ").concat(chalk_1.default.blue(project), " project.");
                        })];
            }
        });
    });
}
exports.default = loginFlow;
