"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var oas_normalize_1 = __importStar(require("oas-normalize"));
var ora_1 = __importDefault(require("ora"));
var isCI_1 = __importDefault(require("./isCI"));
var logger_1 = require("./logger");
var promptWrapper_1 = __importDefault(require("./promptWrapper"));
var readdirRecursive_1 = __importDefault(require("./readdirRecursive"));
var capitalizeSpecType = function (type) {
    return type === 'openapi' ? 'OpenAPI' : type.charAt(0).toUpperCase() + type.slice(1);
};
/**
 * Normalizes, validates, and (optionally) bundles an OpenAPI definition.
 *
 * @param path Path to a spec file. If this is missing, the current directory is searched for
 *    certain file names.
 * @param command The command context in which this is being run within (uploading a spec,
 *    validation, or reducing one).
 */
function prepareOas(path, command, opts) {
    if (opts === void 0) { opts = {
        convertToLatest: false,
    }; }
    return __awaiter(this, void 0, void 0, function () {
        var specPath, fileFindingSpinner, action, jsonAndYamlFiles, possibleSpecFiles, selection, spinner, oas, _a, specType, definitionVersion, api, specFileType, specVersion;
        var _this = this;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    specPath = path;
                    if (!!specPath) return [3 /*break*/, 4];
                    fileFindingSpinner = (0, ora_1.default)(__assign({ text: 'Looking for API definitions...' }, (0, logger_1.oraOptions)())).start();
                    action = void 0;
                    switch (command) {
                        case 'openapi':
                            action = 'upload';
                            break;
                        default:
                            action = command.split(':')[1];
                    }
                    jsonAndYamlFiles = (0, readdirRecursive_1.default)('.', true).filter(function (file) {
                        return file.toLowerCase().endsWith('.json') ||
                            file.toLowerCase().endsWith('.yaml') ||
                            file.toLowerCase().endsWith('.yml');
                    });
                    (0, logger_1.debug)("number of JSON or YAML files found: ".concat(jsonAndYamlFiles.length));
                    return [4 /*yield*/, Promise.all(jsonAndYamlFiles.map(function (file) {
                            (0, logger_1.debug)("attempting to oas-normalize ".concat(file));
                            var oas = new oas_normalize_1.default(file, { enablePaths: true });
                            return oas
                                .version()
                                .then(function (_a) {
                                var specification = _a.specification, version = _a.version;
                                (0, logger_1.debug)("specification type for ".concat(file, ": ").concat(specification));
                                (0, logger_1.debug)("version for ".concat(file, ": ").concat(version));
                                return ['openapi', 'swagger', 'postman'].includes(specification)
                                    ? { filePath: file, specType: capitalizeSpecType(specification), version: version }
                                    : null;
                            })
                                .catch(function (e) {
                                (0, logger_1.debug)("error extracting API definition specification version for ".concat(file, ": ").concat(e.message));
                                return null;
                            });
                        }))];
                case 1:
                    possibleSpecFiles = (_b.sent()).filter(Boolean);
                    (0, logger_1.debug)("number of possible OpenAPI/Swagger files found: ".concat(possibleSpecFiles.length));
                    if (!possibleSpecFiles.length) {
                        fileFindingSpinner.fail();
                        throw new Error("We couldn't find an OpenAPI or Swagger definition.\n\nPlease specify the path to your definition with `rdme ".concat(command, " ./path/to/api/definition`."));
                    }
                    specPath = possibleSpecFiles[0].filePath;
                    if (!(possibleSpecFiles.length === 1)) return [3 /*break*/, 2];
                    fileFindingSpinner.stop();
                    (0, logger_1.info)(chalk_1.default.yellow("We found ".concat(specPath, " and are attempting to ").concat(action, " it.")));
                    return [3 /*break*/, 4];
                case 2:
                    if (!(possibleSpecFiles.length > 1)) return [3 /*break*/, 4];
                    if ((0, isCI_1.default)()) {
                        fileFindingSpinner.fail();
                        throw new Error('Multiple API definitions found in current directory. Please specify file.');
                    }
                    fileFindingSpinner.stop();
                    return [4 /*yield*/, (0, promptWrapper_1.default)({
                            name: 'file',
                            message: "Multiple potential API definitions found! Which one would you like to ".concat(action, "?"),
                            type: 'select',
                            choices: possibleSpecFiles.map(function (file) { return ({
                                title: file.filePath,
                                value: file.filePath,
                                description: "".concat(file.specType, " ").concat(file.version),
                            }); }),
                        })];
                case 3:
                    selection = _b.sent();
                    specPath = selection.file;
                    _b.label = 4;
                case 4:
                    spinner = (0, ora_1.default)(__assign({ text: "Validating the API definition located at ".concat(specPath, "...") }, (0, logger_1.oraOptions)())).start();
                    (0, logger_1.debug)("about to normalize spec located at ".concat(specPath));
                    oas = new oas_normalize_1.default(specPath, { colorizeErrors: true, enablePaths: true });
                    (0, logger_1.debug)('spec normalized');
                    return [4 /*yield*/, oas.load().then(function (schema) { return __awaiter(_this, void 0, void 0, function () {
                            var type;
                            var _a;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        type = (0, oas_normalize_1.getAPIDefinitionType)(schema);
                                        _a = {
                                            specType: capitalizeSpecType(type)
                                        };
                                        return [4 /*yield*/, oas.version()];
                                    case 1: return [2 /*return*/, (_a.definitionVersion = _b.sent(),
                                            _a)];
                                }
                            });
                        }); })];
                case 5:
                    _a = _b.sent(), specType = _a.specType, definitionVersion = _a.definitionVersion;
                    return [4 /*yield*/, oas.validate({ convertToLatest: opts.convertToLatest }).catch(function (err) {
                            spinner.fail();
                            (0, logger_1.debug)("raw validation error object: ".concat(JSON.stringify(err)));
                            throw err;
                        })];
                case 6:
                    api = _b.sent();
                    spinner.stop();
                    (0, logger_1.debug)('👇👇👇👇👇 spec validated! logging spec below 👇👇👇👇👇');
                    (0, logger_1.debug)(api);
                    (0, logger_1.debug)('👆👆👆👆👆 finished logging spec 👆👆👆👆👆');
                    (0, logger_1.debug)("spec type: ".concat(specType));
                    if (opts.title) {
                        (0, logger_1.debug)("renaming title field to ".concat(opts.title));
                        api.info.title = opts.title;
                    }
                    specFileType = oas.type;
                    specVersion = api.info.version;
                    (0, logger_1.debug)("version in spec: ".concat(specVersion));
                    if (!['openapi', 'openapi:inspect', 'openapi:reduce'].includes(command)) return [3 /*break*/, 8];
                    return [4 /*yield*/, oas.bundle()];
                case 7:
                    api = _b.sent();
                    (0, logger_1.debug)('spec bundled');
                    _b.label = 8;
                case 8: return [2 /*return*/, {
                        preparedSpec: JSON.stringify(api),
                        /** A string indicating whether the spec file is a local path, a URL, etc. */
                        specFileType: specFileType,
                        /** The path/URL to the spec file */
                        specPath: specPath,
                        /** A string indicating whether the spec file is OpenAPI, Swagger, etc. */
                        specType: specType,
                        /**
                         * The `info.version` field, extracted from the normalized spec.
                         * This is **not** the OpenAPI version (e.g., 3.1, 3.0),
                         * this is a user input that we use to specify the version in ReadMe
                         * (if they use the `useSpecVersion` flag)
                         */
                        specVersion: specVersion,
                        /**
                         * This is the `openapi`, `swagger`, or `postman` specification version of their API definition.
                         */
                        definitionVersion: definitionVersion,
                    }];
            }
        });
    });
}
exports.default = prepareOas;
