"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createVersionPrompt = exports.createOasPrompt = void 0;
var parse_link_header_1 = __importDefault(require("parse-link-header"));
var semver_1 = __importDefault(require("semver"));
var promptWrapper_1 = __importDefault(require("./promptWrapper"));
var readmeAPIFetch_1 = require("./readmeAPIFetch");
function specOptions(specList, parsedDocs, currPage, totalPages) {
    var _a, _b;
    var specs = specList.map(function (s) {
        return {
            description: "API Definition ID: ".concat(s._id),
            title: s.title,
            value: s._id, // eslint-disable-line no-underscore-dangle
        };
    });
    if ((_a = parsedDocs === null || parsedDocs === void 0 ? void 0 : parsedDocs.prev) === null || _a === void 0 ? void 0 : _a.page) {
        specs.push({
            description: 'Go to the previous page',
            title: "< Prev (page ".concat(currPage - 1, " of ").concat(totalPages, ")"),
            value: 'prev',
        });
    }
    if ((_b = parsedDocs === null || parsedDocs === void 0 ? void 0 : parsedDocs.next) === null || _b === void 0 ? void 0 : _b.page) {
        specs.push({
            description: 'Go to the next page',
            title: "Next (page ".concat(currPage + 1, " of ").concat(totalPages, ") >"),
            value: 'next',
        });
    }
    return specs;
}
var updateOasPrompt = function (specList, parsedDocs, currPage, totalPages, getSpecs) { return [
    {
        type: 'select',
        name: 'specId',
        message: 'Select your desired file to update',
        choices: specOptions(specList, parsedDocs, currPage, totalPages),
        format: function (spec) {
            return __awaiter(this, void 0, void 0, function () {
                var newSpecs, newParsedDocs, newSpecList, specId, e_1, newSpecs, newParsedDocs, newSpecList, specId, e_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(spec === 'prev')) return [3 /*break*/, 7];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 5, , 6]);
                            return [4 /*yield*/, getSpecs("".concat(parsedDocs.prev.url))];
                        case 2:
                            newSpecs = _a.sent();
                            newParsedDocs = (0, parse_link_header_1.default)(newSpecs.headers.get('link'));
                            return [4 /*yield*/, (0, readmeAPIFetch_1.handleRes)(newSpecs)];
                        case 3:
                            newSpecList = _a.sent();
                            return [4 /*yield*/, (0, promptWrapper_1.default)(updateOasPrompt(newSpecList, newParsedDocs, currPage - 1, totalPages, getSpecs))];
                        case 4:
                            specId = (_a.sent()).specId;
                            return [2 /*return*/, specId];
                        case 5:
                            e_1 = _a.sent();
                            return [2 /*return*/, null];
                        case 6: return [3 /*break*/, 13];
                        case 7:
                            if (!(spec === 'next')) return [3 /*break*/, 13];
                            _a.label = 8;
                        case 8:
                            _a.trys.push([8, 12, , 13]);
                            return [4 /*yield*/, getSpecs("".concat(parsedDocs.next.url))];
                        case 9:
                            newSpecs = _a.sent();
                            newParsedDocs = (0, parse_link_header_1.default)(newSpecs.headers.get('link'));
                            return [4 /*yield*/, (0, readmeAPIFetch_1.handleRes)(newSpecs)];
                        case 10:
                            newSpecList = _a.sent();
                            return [4 /*yield*/, (0, promptWrapper_1.default)(updateOasPrompt(newSpecList, newParsedDocs, currPage + 1, totalPages, getSpecs))];
                        case 11:
                            specId = (_a.sent()).specId;
                            return [2 /*return*/, specId];
                        case 12:
                            e_2 = _a.sent();
                            return [2 /*return*/, null];
                        case 13: return [2 /*return*/, spec];
                    }
                });
            });
        },
    },
]; };
function createOasPrompt(specList, parsedDocs, totalPages, getSpecs) {
    return [
        {
            type: 'select',
            name: 'option',
            message: 'Would you like to update an existing OAS file or create a new one?',
            choices: [
                { title: 'Update existing', value: 'update' },
                { title: 'Create a new spec', value: 'create' },
            ],
            format: function (picked) {
                return __awaiter(this, void 0, void 0, function () {
                    var specId;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!(picked === 'update')) return [3 /*break*/, 2];
                                return [4 /*yield*/, (0, promptWrapper_1.default)(updateOasPrompt(specList, parsedDocs, 1, totalPages, getSpecs))];
                            case 1:
                                specId = (_a.sent()).specId;
                                return [2 /*return*/, specId];
                            case 2: return [2 /*return*/, picked];
                        }
                    });
                });
            },
        },
    ];
}
exports.createOasPrompt = createOasPrompt;
function createVersionPrompt(versionList, opts, isUpdate) {
    return [
        {
            type: opts.fork || isUpdate ? null : 'select',
            name: 'from',
            message: 'Which version would you like to fork from?',
            choices: versionList.map(function (v) {
                return {
                    title: v.version,
                    value: v.version,
                };
            }),
        },
        {
            type: opts.newVersion || !isUpdate ? null : 'text',
            name: 'newVersion',
            message: 'What should the version be renamed to?',
            initial: opts.newVersion || false,
            hint: '1.0.0',
            validate: function (val) {
                return semver_1.default.valid(semver_1.default.coerce(val)) ? true : 'Please specify a semantic version.';
            },
        },
        {
            type: opts.main || (isUpdate === null || isUpdate === void 0 ? void 0 : isUpdate.is_stable) ? null : 'confirm',
            name: 'is_stable',
            message: 'Would you like to make this version the main version for this project?',
        },
        {
            type: opts.beta ? null : 'confirm',
            name: 'is_beta',
            message: 'Should this version be in beta?',
        },
        {
            type: function (prev, values) {
                return opts.isPublic || opts.main || values.is_stable ? null : 'confirm';
            },
            name: 'is_hidden',
            message: 'Would you like to make this version public?',
        },
        {
            type: function (prev, values) {
                return opts.deprecated || opts.main || !isUpdate || values.is_stable ? null : 'confirm';
            },
            name: 'is_deprecated',
            message: 'Would you like to deprecate this version?',
        },
    ];
}
exports.createVersionPrompt = createVersionPrompt;
