"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleRes = exports.getUserAgent = exports.cleanHeaders = void 0;
var path_1 = __importDefault(require("path"));
var config_1 = __importDefault(require("config"));
var mime_types_1 = __importDefault(require("mime-types"));
var node_fetch_1 = __importStar(require("node-fetch")); // eslint-disable-line no-restricted-imports
var package_json_1 = __importDefault(require("../../package.json"));
var apiError_1 = __importDefault(require("./apiError"));
var createGHA_1 = require("./createGHA");
var isCI_1 = __importStar(require("./isCI"));
var logger_1 = require("./logger");
var SUCCESS_NO_CONTENT = 204;
function getProxy() {
    // this is something of an industry standard env var, hence the checks for different casings
    var proxy = process.env.HTTPS_PROXY || process.env.https_proxy;
    if (proxy) {
        // adds trailing slash
        return proxy.endsWith('/') ? proxy : "".concat(proxy, "/");
    }
    return '';
}
function stripQuotes(s) {
    if (!s)
        return '';
    return s.replace(/(^"|[",]*$)/g, '');
}
/**
 * Parses Warning header into an array of warning header objects
 * @param header raw `Warning` header
 * @see {@link https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Warning}
 * @see {@link https://www.rfc-editor.org/rfc/rfc7234#section-5.5}
 * @see {@link https://github.com/marcbachmann/warning-header-parser}
 */
function parseWarningHeader(header) {
    try {
        var warnings = header.split(/([0-9]{3} [a-z0-9.@\-/]*) /g);
        var previous_1;
        return warnings.reduce(function (all, w) {
            // eslint-disable-next-line no-param-reassign
            w = w.trim();
            var newError = w.match(/^([0-9]{3}) (.*)/);
            if (newError) {
                previous_1 = { code: newError[1], agent: newError[2], message: '' };
            }
            else if (w) {
                var errorContent = w.split(/" "/);
                if (errorContent) {
                    previous_1.message = stripQuotes(errorContent[0]);
                    previous_1.date = stripQuotes(errorContent[1]);
                    all.push(previous_1);
                }
            }
            return all;
        }, []);
    }
    catch (e) {
        (0, logger_1.debug)("error parsing warning header: ".concat(e.message));
        return [{ code: '199', agent: '-', message: header }];
    }
}
/**
 * Getter function for a string to be used in the user-agent header based on the current
 * environment.
 *
 */
function getUserAgent() {
    var gh = (0, isCI_1.isGHA)() ? '-github' : '';
    return "rdme".concat(gh, "/").concat(package_json_1.default.version);
}
exports.getUserAgent = getUserAgent;
/**
 * Creates a relative path for the file from the root of the repo,
 * otherwise returns the path
 */
function normalizeFilePath(opts) {
    return __awaiter(this, void 0, void 0, function () {
        var repoRoot;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(opts.fileType === 'path')) return [3 /*break*/, 2];
                    return [4 /*yield*/, createGHA_1.git.revparse(['--show-toplevel']).catch(function (e) {
                            (0, logger_1.debug)("[fetch] error grabbing git root: ".concat(e.message));
                            return '';
                        })];
                case 1:
                    repoRoot = _a.sent();
                    return [2 /*return*/, path_1.default.relative(repoRoot, opts.filePath)];
                case 2: return [2 /*return*/, opts.filePath];
            }
        });
    });
}
/**
 * Sanitizes and stringifies the `Headers` object for logging purposes
 */
function sanitizeHeaders(headers) {
    var raw = new node_fetch_1.Headers(headers).raw();
    if (raw.Authorization)
        raw.Authorization = ['redacted'];
    return JSON.stringify(raw);
}
/**
 * Wrapper for the `fetch` API so we can add rdme-specific headers to all API requests.
 *
 * @param pathname the pathname to make the request to. Must have a leading slash.
 * @param fileOpts optional object containing information about the file being sent.
 * We use this to construct a full source URL for the file.
 */
function readmeAPIFetch(pathname, options, fileOpts) {
    if (options === void 0) { options = { headers: new node_fetch_1.Headers() }; }
    if (fileOpts === void 0) { fileOpts = { filePath: '', fileType: false }; }
    return __awaiter(this, void 0, void 0, function () {
        var source, headers, filePath, sourceUrl, fullUrl;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    source = 'cli';
                    headers = options.headers;
                    if (!(options.headers instanceof node_fetch_1.Headers)) {
                        headers = new node_fetch_1.Headers(options.headers);
                    }
                    headers.set('User-Agent', getUserAgent());
                    if (!(0, isCI_1.isGHA)()) return [3 /*break*/, 2];
                    source = 'cli-gh';
                    headers.set('x-github-repository', process.env.GITHUB_REPOSITORY);
                    headers.set('x-github-run-attempt', process.env.GITHUB_RUN_ATTEMPT);
                    headers.set('x-github-run-id', process.env.GITHUB_RUN_ID);
                    headers.set('x-github-run-number', process.env.GITHUB_RUN_NUMBER);
                    headers.set('x-github-sha', process.env.GITHUB_SHA);
                    return [4 /*yield*/, normalizeFilePath(fileOpts)];
                case 1:
                    filePath = _a.sent();
                    if (filePath) {
                        /**
                         * Constructs a full URL to the file using GitHub Actions runner variables
                         * @see {@link https://docs.github.com/en/actions/learn-github-actions/environment-variables#default-environment-variables}
                         * @example https://github.com/readmeio/rdme/blob/cb4129d5c7b51ff3b50f933a9c7d0c3d0d33d62c/documentation/rdme.md
                         */
                        try {
                            sourceUrl = new URL("".concat(process.env.GITHUB_SERVER_URL, "/").concat(process.env.GITHUB_REPOSITORY, "/blob/").concat(process.env.GITHUB_SHA, "/").concat(filePath)).href;
                            headers.set('x-readme-source-url', sourceUrl);
                        }
                        catch (e) {
                            (0, logger_1.debug)("error constructing github source url: ".concat(e.message));
                        }
                    }
                    _a.label = 2;
                case 2:
                    if ((0, isCI_1.default)()) {
                        headers.set('x-rdme-ci', (0, isCI_1.ciName)());
                    }
                    headers.set('x-readme-source', source);
                    if (fileOpts.filePath && fileOpts.fileType === 'url') {
                        headers.set('x-readme-source-url', fileOpts.filePath);
                    }
                    fullUrl = "".concat(getProxy()).concat(config_1.default.get('host')).concat(pathname);
                    (0, logger_1.debug)("making ".concat((options.method || 'get').toUpperCase(), " request to ").concat(fullUrl, " with headers: ").concat(sanitizeHeaders(headers)));
                    return [2 /*return*/, (0, node_fetch_1.default)(fullUrl, __assign(__assign({}, options), { headers: headers })).then(function (res) {
                            var warningHeader = res.headers.get('Warning');
                            if (warningHeader) {
                                (0, logger_1.debug)("received warning header: ".concat(warningHeader));
                                var warnings = parseWarningHeader(warningHeader);
                                warnings.forEach(function (warning) {
                                    (0, logger_1.warn)(warning.message, 'ReadMe API Warning:');
                                });
                            }
                            return res;
                        })];
            }
        });
    });
}
exports.default = readmeAPIFetch;
/**
 * Small handler for handling responses from our API.
 *
 * If we receive JSON errors, we throw an APIError exception.
 *
 * If we receive non-JSON responses, we consider them errors and throw them.
 *
 * @param rejectOnJsonError if omitted (or set to true), the function will return
 * an `APIError` if the JSON body contains an `error` property. If set to false,
 * the function will return a resolved promise containing the JSON object.
 *
 */
function handleRes(res, rejectOnJsonError) {
    if (rejectOnJsonError === void 0) { rejectOnJsonError = true; }
    return __awaiter(this, void 0, void 0, function () {
        var contentType, extension, body_1, body;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    contentType = res.headers.get('content-type');
                    extension = mime_types_1.default.extension(contentType);
                    if (!(extension === 'json')) return [3 /*break*/, 2];
                    return [4 /*yield*/, res.json()];
                case 1:
                    body_1 = _a.sent();
                    (0, logger_1.debug)("received status code ".concat(res.status, " from ").concat(res.url, " with JSON response: ").concat(JSON.stringify(body_1)));
                    if (body_1.error && rejectOnJsonError) {
                        return [2 /*return*/, Promise.reject(new apiError_1.default(body_1))];
                    }
                    return [2 /*return*/, body_1];
                case 2:
                    if (res.status === SUCCESS_NO_CONTENT) {
                        (0, logger_1.debug)("received status code ".concat(res.status, " from ").concat(res.url, " with no content"));
                        return [2 /*return*/, {}];
                    }
                    return [4 /*yield*/, res.text()];
                case 3:
                    body = _a.sent();
                    (0, logger_1.debug)("received status code ".concat(res.status, " from ").concat(res.url, " with non-JSON response: ").concat(body));
                    return [2 /*return*/, Promise.reject(body)];
            }
        });
    });
}
exports.handleRes = handleRes;
/**
 * Returns the basic auth header and any other defined headers for use in `node-fetch` API calls.
 *
 */
function cleanHeaders(key, inputHeaders) {
    var e_1, _a;
    if (inputHeaders === void 0) { inputHeaders = new node_fetch_1.Headers(); }
    var encodedKey = Buffer.from("".concat(key, ":")).toString('base64');
    var headers = new node_fetch_1.Headers({
        Authorization: "Basic ".concat(encodedKey),
    });
    try {
        for (var _b = __values(inputHeaders.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
            var header = _c.value;
            // If you supply `undefined` or `null` to the `Headers` API it'll convert that those to a
            // string.
            if (header[1] !== 'null' && header[1] !== 'undefined' && header[1].length > 0) {
                headers.set(header[0], header[1]);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return headers;
}
exports.cleanHeaders = cleanHeaders;
