"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var promises_1 = __importDefault(require("fs/promises"));
var path_1 = __importDefault(require("path"));
var chalk_1 = __importDefault(require("chalk"));
var config_1 = __importDefault(require("config"));
var node_fetch_1 = require("node-fetch");
var apiError_1 = __importDefault(require("./apiError"));
var baseCommand_1 = __importStar(require("./baseCommand"));
var logger_1 = require("./logger");
var readdirRecursive_1 = __importDefault(require("./readdirRecursive"));
var readDoc_1 = __importDefault(require("./readDoc"));
var readmeAPIFetch_1 = __importStar(require("./readmeAPIFetch"));
/**
 * Reads the contents of the specified Markdown or HTML file
 * and creates/updates the corresponding doc in ReadMe
 *
 * @param key the project API key
 * @param selectedVersion the project version
 * @param dryRun boolean indicating dry run mode
 * @param filePath path to file
 * @param type module within ReadMe to update (e.g. docs, changelogs, etc.)
 * @returns A promise-wrapped string with the result
 */
function pushDoc(key, selectedVersion, dryRun, filePath, type) {
    return __awaiter(this, void 0, void 0, function () {
        function createDoc() {
            if (dryRun) {
                return "\uD83C\uDFAD dry run! This will create '".concat(slug, "' with contents from ").concat(filePath, " with the following metadata: ").concat(JSON.stringify(data));
            }
            return ((0, readmeAPIFetch_1.default)("/api/v1/".concat(type), {
                method: 'post',
                headers: (0, readmeAPIFetch_1.cleanHeaders)(key, new node_fetch_1.Headers({
                    'x-readme-version': selectedVersion,
                    'Content-Type': 'application/json',
                })),
                body: JSON.stringify(__assign({ slug: slug }, payload)),
            }, { filePath: filePath, fileType: 'path' })
                .then(readmeAPIFetch_1.handleRes)
                // eslint-disable-next-line no-underscore-dangle
                .then(function (res) { return "\uD83C\uDF31 successfully created '".concat(res.slug, "' (ID: ").concat(res._id, ") with contents from ").concat(filePath); }));
        }
        function updateDoc(existingDoc) {
            if (hash === existingDoc.lastUpdatedHash) {
                return "".concat(dryRun ? '🎭 dry run! ' : '', "`").concat(slug, "` ").concat(dryRun ? 'will not be' : 'was not', " updated because there were no changes.");
            }
            if (dryRun) {
                return "\uD83C\uDFAD dry run! This will update '".concat(slug, "' with contents from ").concat(filePath, " with the following metadata: ").concat(JSON.stringify(data));
            }
            return (0, readmeAPIFetch_1.default)("/api/v1/".concat(type, "/").concat(slug), {
                method: 'put',
                headers: (0, readmeAPIFetch_1.cleanHeaders)(key, new node_fetch_1.Headers({
                    'x-readme-version': selectedVersion,
                    'Content-Type': 'application/json',
                })),
                body: JSON.stringify(payload),
            }, { filePath: filePath, fileType: 'path' })
                .then(readmeAPIFetch_1.handleRes)
                .then(function (res) { return "\u270F\uFE0F successfully updated '".concat(res.slug, "' with contents from ").concat(filePath); });
        }
        var _a, content, data, hash, slug, payload;
        var _this = this;
        return __generator(this, function (_b) {
            _a = (0, readDoc_1.default)(filePath), content = _a.content, data = _a.data, hash = _a.hash, slug = _a.slug;
            // TODO: ideally we should offer a zero-configuration approach that doesn't
            // require YAML front matter, but that will have to be a breaking change
            if (!Object.keys(data).length) {
                (0, logger_1.debug)("No front matter attributes found for ".concat(filePath, ", not syncing"));
                return [2 /*return*/, "\u23ED\uFE0F  no front matter attributes found for ".concat(filePath, ", skipping")];
            }
            payload = __assign(__assign({ body: content }, data), { lastUpdatedHash: hash });
            if (type === baseCommand_1.CommandCategories.CUSTOM_PAGES) {
                if (filePath.endsWith('.html')) {
                    payload = __assign(__assign({ html: content, htmlmode: true }, data), { lastUpdatedHash: hash });
                }
                else {
                    payload = __assign(__assign({ body: content, htmlmode: false }, data), { lastUpdatedHash: hash });
                }
            }
            return [2 /*return*/, (0, readmeAPIFetch_1.default)("/api/v1/".concat(type, "/").concat(slug), {
                    method: 'get',
                    headers: (0, readmeAPIFetch_1.cleanHeaders)(key, new node_fetch_1.Headers({
                        'x-readme-version': selectedVersion,
                        Accept: 'application/json',
                    })),
                })
                    .then(function (res) { return __awaiter(_this, void 0, void 0, function () {
                    var body;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, (0, readmeAPIFetch_1.handleRes)(res, false)];
                            case 1:
                                body = _a.sent();
                                if (!res.ok) {
                                    if (res.status !== 404)
                                        return [2 /*return*/, Promise.reject(new apiError_1.default(body))];
                                    (0, logger_1.debug)("error retrieving data for ".concat(slug, ", creating doc"));
                                    return [2 /*return*/, createDoc()];
                                }
                                (0, logger_1.debug)("data received for ".concat(slug, ", updating doc"));
                                return [2 /*return*/, updateDoc(body)];
                        }
                    });
                }); })
                    .catch(function (err) {
                    // eslint-disable-next-line no-param-reassign
                    err.message = "Error uploading ".concat(chalk_1.default.underline(filePath), ":\n\n").concat(err.message);
                    throw err;
                })];
        });
    });
}
/**
 * Takes a path (either to a directory of files or to a single file)
 * and syncs those (either via POST or PUT) to ReadMe.
 * @returns A promise-wrapped string with the results
 */
function syncDocsPath(
/** Project API key */
key, 
/** ReadMe project version */
selectedVersion, 
/** module within ReadMe to update (e.g. docs, changelogs, etc.) */
cmdType, 
/** Example command usage, used in error message */
usage, 
/** Path input, can either be a directory or a single file */
pathInput, 
/** boolean indicating dry run mode */
dryRun, 
/** array of allowed file extensions */
allowedFileExtensions) {
    if (allowedFileExtensions === void 0) { allowedFileExtensions = ['.markdown', '.md']; }
    return __awaiter(this, void 0, void 0, function () {
        var stat, output, files, fileExtension;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!pathInput) {
                        return [2 /*return*/, Promise.reject(new Error("No path provided. Usage `".concat(config_1.default.get('cli'), " ").concat(usage, "`.")))];
                    }
                    return [4 /*yield*/, promises_1.default.stat(pathInput).catch(function (err) {
                            if (err.code === 'ENOENT') {
                                throw new Error("Oops! We couldn't locate a file or directory at the path you provided.");
                            }
                            throw err;
                        })];
                case 1:
                    stat = _a.sent();
                    if (!stat.isDirectory()) return [3 /*break*/, 3];
                    files = (0, readdirRecursive_1.default)(pathInput).filter(function (file) {
                        return allowedFileExtensions.includes(path_1.default.extname(file).toLowerCase());
                    });
                    baseCommand_1.default.debug("number of files: ".concat(files.length));
                    if (!files.length) {
                        return [2 /*return*/, Promise.reject(new Error("The directory you provided (".concat(pathInput, ") doesn't contain any of the following required files: ").concat(allowedFileExtensions.join(', '), ".")))];
                    }
                    return [4 /*yield*/, Promise.all(files.map(function (filename) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                return [2 /*return*/, pushDoc(key, selectedVersion, dryRun, filename, cmdType)];
                            });
                        }); }))];
                case 2:
                    output = (_a.sent()).join('\n');
                    return [3 /*break*/, 5];
                case 3:
                    fileExtension = path_1.default.extname(pathInput).toLowerCase();
                    if (!allowedFileExtensions.includes(fileExtension)) {
                        return [2 /*return*/, Promise.reject(new Error("Invalid file extension (".concat(fileExtension, "). Must be one of the following: ").concat(allowedFileExtensions.join(', '))))];
                    }
                    return [4 /*yield*/, pushDoc(key, selectedVersion, dryRun, pathInput, cmdType)];
                case 4:
                    output = _a.sent();
                    _a.label = 5;
                case 5: return [2 /*return*/, Promise.resolve(chalk_1.default.green(output))];
            }
        });
    });
}
exports.default = syncDocsPath;
