"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getProjectVersion = void 0;
var apiError_1 = __importDefault(require("./apiError"));
var isCI_1 = __importDefault(require("./isCI"));
var logger_1 = require("./logger");
var promptWrapper_1 = __importDefault(require("./promptWrapper"));
var readmeAPIFetch_1 = __importStar(require("./readmeAPIFetch"));
/**
 * Validates and returns a project version.
 *
 * @param versionFlag version input parameter
 * @param key project API key
 * @returns a cleaned up project version
 */
function getProjectVersion(versionFlag, key, returnStable) {
    if (returnStable === void 0) { returnStable = false; }
    return __awaiter(this, void 0, void 0, function () {
        var versionList, stableVersion, versionSelection, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 5, , 6]);
                    if (!versionFlag) return [3 /*break*/, 2];
                    return [4 /*yield*/, (0, readmeAPIFetch_1.default)("/api/v1/version/".concat(versionFlag), {
                            method: 'get',
                            headers: (0, readmeAPIFetch_1.cleanHeaders)(key),
                        })
                            .then(readmeAPIFetch_1.handleRes)
                            .then(function (res) { return res.version; })];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    if ((0, isCI_1.default)()) {
                        (0, logger_1.warn)('No `--version` parameter detected in current CI environment. Defaulting to main version.');
                        return [2 /*return*/, undefined];
                    }
                    return [4 /*yield*/, (0, readmeAPIFetch_1.default)('/api/v1/version', {
                            method: 'get',
                            headers: (0, readmeAPIFetch_1.cleanHeaders)(key),
                        }).then(readmeAPIFetch_1.handleRes)];
                case 3:
                    versionList = _a.sent();
                    if (versionList.length === 1) {
                        return [2 /*return*/, versionList[0].version];
                    }
                    if (returnStable) {
                        stableVersion = versionList.find(function (v) { return v.is_stable === true; });
                        return [2 /*return*/, stableVersion.version];
                    }
                    return [4 /*yield*/, (0, promptWrapper_1.default)({
                            type: 'select',
                            name: 'versionSelection',
                            message: 'Select your desired version',
                            choices: versionList.map(function (v) {
                                return {
                                    title: v.version,
                                    value: v.version,
                                };
                            }),
                        })];
                case 4:
                    versionSelection = (_a.sent()).versionSelection;
                    return [2 /*return*/, versionSelection];
                case 5:
                    err_1 = _a.sent();
                    return [2 /*return*/, Promise.reject(new apiError_1.default(err_1))];
                case 6: return [2 /*return*/];
            }
        });
    });
}
exports.getProjectVersion = getProjectVersion;
